/*
 * Copyright 2021 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "common.h"

const char* GetErrString(ERR eErr)
{
    switch(eErr) {
    case ERR_NONE:              return "ERR_NONE";
    case ERR_SEQ:               return "ERR_SEQ";
    case ERR_COMMAND:           return "ERR_COMMAND";
    case ERR_BOARD_FLASH:       return "ERR_BOARD_FLASH";
    case ERR_PEB_NUMBER:        return "ERR_PEB_NUMBER";
    case ERR_SUBSECTOR_NUMBER:  return "ERR_SUBSECTOR_NUMBER";
    case ERR_ERASE:             return "ERR_ERASE";
    case ERR_READ:              return "ERR_READ";
    case ERR_WRITE:             return "ERR_WRITE";
    case ERR_FLASH_UNVERIFIED:  return "ERR_FLASH_UNVERIFIED";
    case ERR_PEB_SIZE:          return "ERR_PEB_SIZE";
    case ERR_SUBSECTOR_SIZE:    return "ERR_SUBSECTOR_SIZE";
    case ERR_IMAGE_SIZE:        return "ERR_IMAGE_SIZE";
    case ERR_CHECKSUM:          return "ERR_CHECKSUM";
    case ERR_MULTIBOOT_BYTES:   return "ERR_MULTIBOOT_BYTES";
    case ERR_IMAGE_ALIGNMENT:   return "ERR_IMAGE_ALIGNMENT";
    case ERR_BSP:               return "ERR_BSP";
    case ERR_TIMEOUT:           return "ERR_TIMEOUT";
    case ERR_INTERNAL:          return "ERR_INTERNAL";
    default:                    return "ERR_???";
    }
}

const char* GetCommandString(COMMAND eCommand)
{
    switch(eCommand) {
    case COMMAND_INVALID:               return "COMMAND_INVALID";
    case COMMAND_VERIFY_FLASH:          return "COMMAND_VERIFY_FLASH";
    case COMMAND_VERIFY_IMAGE:          return "COMMAND_VERIFY_IMAGE";
    case COMMAND_GET_MULTIBOOT_BYTES:   return "COMMAND_GET_MULTIBOOT_BYTES";
    case COMMAND_ERASE_PEBS:            return "COMMAND_ERASE_PEBS";
    case COMMAND_READ_PEB:              return "COMMAND_READ_PEB";
    case COMMAND_WRITE_PEB:             return "COMMAND_WRITE_PEB";
    case COMMAND_ERASE_SUBSECTOR:       return "COMMAND_ERASE_SUBSECTOR";
    case COMMAND_READ_SUBSECTOR:        return "COMMAND_READ_SUBSECTOR";
    case COMMAND_WRITE_SUBSECTOR:       return "COMMAND_WRITE_SUBSECTOR";
    case COMMAND_SIM_STOP:              return "COMMAND_SIM_STOP";
    default:                            return "COMMAND_???";
    }
}
