/*
 * Copyright 2021 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <stdint.h>
#include "xparameters.h"
#include "xuartpsv.h"
#include "xil_printf.h"
#include "sleep.h"

/* ------------------------------------------------------------------ */
void InitUart(void)
{
    XUartPsv tUartPsv;
    XUartPsv_Config* Config;
    int Status;
    
    Config = XUartPsv_LookupConfig(0);
    if( NULL == Config) {
        return;
    }
    Status = XUartPsv_CfgInitialize(&tUartPsv, Config, Config->BaseAddress);
    if (Status != XST_SUCCESS) {
        return;
    }
}

/* ------------------------------------------------------------------ */

#define NOTHING
int main(void)
{
    uint32_t q;

    InitUart();
    xil_printf("Build info: %s %s\n\r",__DATE__,__TIME__);

    for(q = 0; NOTHING; NOTHING) {
        xil_printf("%08x\n\r",q++);
        usleep(1000000);
    }

    /*
     * Not reached
     */
    __builtin_unreachable();
    return 0;
}
