/*
 * Copyright 2021 Xilinx, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef R5_MULTIBOOT_H__
#define R5_MULTIBOOT_H__

#define EMIO_MULTIBOOT  (1 << 0)    /* Input */
#define EMIO_CPLD_UP    (1 << 1)    /* Input */
#define EMIO_PCIE_GOOD  (1 << 2)    /* Input */
#define EMIO_R5_UP      (1 << 3)    /* Output */

#define EMIO_PCIE_GOOD_COUNTER_TIMEOUT  0x3fffffff
struct MultibootState;
typedef struct MultibootState MultibootState;

typedef enum PCIE_STATE {
    PCIE_STATE_UNKNOWN,
    PCIE_STATE_UP,
    PCIE_STATE_DOWN
} PCIE_STATE;

struct MultibootState {
    uint32_t qPcieGoodCounter;
    volatile PCIE_STATE ePcieState;
    volatile bool yMultibootRequest;
    uint32_t qMultibootReg;
};

extern void r5InitMultibootState(MultibootState* pMS);
extern void r5SenseMultibootInputs(MultibootState* pMS);
extern __attribute__((noreturn)) void r5PerformMultiboot(MultibootState* pMS);

#endif  /* R5_MULTIBOOT_H__ */
